/****************************************************************

Add Device
Copyright (C) 2008  plixer.com, Eric Joniec

Used by Settings -> Configuration -> Manage Devices -> Add Device

*****************************************************************/

/************************************

startWizard() starts everything off.
Opens pboxes and diplays first window
Called by &confManageNetFlows perl

*************************************/

function startWizard(isFree, myTask){

	if (isFree == "notFree"){

		createIbox(document.getElementsByTagName("body")[0]);

		addStartWizInputs(myTask);

		if (document.getElementById('scrutAdSvc')){
			document.getElementById('scrutAdSvc').id = 'scrutAdSvc2';
		}

		showIndicator();
		showPbox();
		showBG();

		var milliCache = getCacheBreaker();
		var url = 'index.cgi?formResponse=YES&netflowSetWiz=netflowSetWizStart&cachebreaker='+milliCache;

		ajax_loadContent('ibox_content',url, '<center><div style ="background-color:#C0C0C0; vertical-align:middle; width:755px; height:445px" ><img style="position:relative; top:160px" src=\"/images/netFlowWiz.gif\"></img></div></center>');

		window.onscroll = maintPos;
		window.onresize = maintPos;
		return false;
	}
	else {
		if (document.getElementById("formResponse")){
			try {
				document.getElementById("formResponse").value = '';
			}
			catch(e){}
		}

		return true;
	}

}

/************************************

startWizard2() starts everything off.
Opens pboxes and diplays first window
Called by &confManageNetFlows perl

*************************************/

function startWizard2(isFree, myTask, myIp, credId, winClose){

	if (isFree == "notFree"){

		createIbox(document.getElementsByTagName("body")[0]);
		//createIbox(document.getElementById("summaryFormErp"));

		addStartWizInputs(myTask);

		if (document.getElementById('scrutAdSvc')){
			//alert('scrutAdSvc - FOUND');
			document.getElementById('scrutAdSvc').id = 'scrutAdSvc2';
		}
		showIndicator();
		showBG();
		showPbox();

		var milliCache = getCacheBreaker();
		var url = 'index.cgi?formResponse=YES&netflowSetWiz=netflowSetWizStart&windowClose=' + winClose + '&IP=' + myIp + '&credID=' +credId + '&cachebreaker='+milliCache;

		ajax_loadContent('ibox_content',url, '<center><div style ="background-color:#C0C0C0; vertical-align:middle; width:755px; height:445px" ><img style="position:relative; top:160px" src=\"/images/netFlowWiz.gif\"></img></div></center>');

		window.onscroll = maintPos;
		window.onresize = maintPos;

		return false;
	}
	else {
		if (document.getElementById("formResponse")){
			try {
				document.getElementById("formResponse").value = '';
			}
			catch(e){}
		}

		return true;
	}

}

/******************************************************************

addStartWizInputs() is used by startWizard() and closeBuyNowPopUp()

*******************************************************************/

function addStartWizInputs(myTask){
	var myForm = document.getElementById("summaryFormErp");
	if (! document.getElementById("input_a")){
			var input = document.createElement('INPUT');
			input.setAttribute('type', 'hidden');
			input.setAttribute('id','input_a');
			input.name = 'a';
			input.value = myTask;
			myForm.appendChild(input);
	}
	if (! document.getElementById("formResponse")){
		var input = document.createElement('INPUT');
		input.setAttribute('type', 'hidden');
		input.setAttribute('id','formResponse');
		input.name = 'formResponse';
		input.value = 'YES';
		myForm.appendChild(input);
	}
	var netflowSetWiz;
	if (document.getElementById("netflowSetWiz")){
		netflowSetWiz = document.getElementById("netflowSetWiz");
	}
	if (! netflowSetWiz ){
		var input = document.createElement('INPUT');
		input.setAttribute('type', 'hidden');
		input.setAttribute('id','netflowSetWiz');
		input.name = 'netflowSetWiz';
		input.value = 'netflowSetWizStart';
		myForm.appendChild(input);
	}

}

/******************************************************************

netflowSetWiz1() opens second pbox where IP and Cred are entered.

*******************************************************************/

function netflowSetWiz1(winClose,myIp,myCredId) {

	if(document.getElementById('scrutAdSvc')){
		var olddiv = document.getElementById('scrutAdSvc');
		olddiv.id = 'scrutAdSvcOLD';
	}

	var url = 'index.cgi?formResponse=YES&netflowSetWiz=netflowSetWiz1';

	if (myIp){
		url = 'index.cgi?formResponse=YES&netflowSetWiz=netflowSetWiz1&IP=' + myIp;
	}
	if (myCredId){ url += '&credID=' + myCredId; }
	else {
		try {
			myCredId = document.getElementById('credID').value
			url += '&credID=' + myCredId;
		}
		catch(e){}
	}
	var addUrl = checkWinClose(winClose);
	url += addUrl;
	var milliCache = getCacheBreaker();
	url += '&cachebreaker='+milliCache;
	ajax_loadContent('ibox_content', url, '<center><div style ="background-color:#C0C0C0; vertical-align:middle; width:755px; height:445px" ><img style="position:relative; top:160px" src=\"/images/netFlowWiz.gif\"></img></div></center>');
}


/******************************************************************

netflowSetWiz2() opens 3rd pbox
where it Shows the router ingress info, cache timeouts and Server-Reponse.

*******************************************************************/

function netflowSetWiz2(buttonID,inputB,winClose) {

	var nextButton = document.getElementById(buttonID);

	if (validateIPAddress(nextButton)){

		var ip = document.getElementById('rtrIP').value;
		var ipInput = '&ip=' + ip;
		var comString = document.getElementById('rwComString').value;
		var csInput = '&cred_id=' + comString;
		var b = '&b=' + inputB.value;
		var url = 'index.cgi?formResponse=YES&netflowSetWiz=netflowSetWiz2' + ipInput + csInput + b + '&0P=99999';
		var addUrl = checkWinClose(winClose);
		url += addUrl;
		var milliCache = getCacheBreaker();
		url += '&cachebreaker='+milliCache;
		ajax_loadContent('ibox_content',url ,'<center><div style ="background-color:#C0C0C0; vertical-align:middle; width:755px; height:445px" ><img style="position:relative; top:160px" src=\"/images/netFlowWiz.gif\"></img></div></center>');
	}
	else{
		nextButton.style.borderWidth = '5px';
		nextButton.style.borderColor = '#DF0101';
		nextButton.value = '';
		nextButton.focus();
	}
}

/******************************************************************

netflowSetWiz3() gets the inputs from the 3rd pbox
and sends them to the server via ajax_loadContent

*******************************************************************/

function netflowSetWiz3(buttonIN, winClose) {

	var url = 'index.cgi?formResponse=YES&netflowSetWiz=netflowSetWiz3';

	if (buttonIN.name == 'b'){
		var saved = "&" + buttonIN.name + "=" + buttonIN.value;
		url += saved;
	}
	else if (buttonIN == 'delete'){
		var saved = "&b=Save";
		url += saved;
	}
	var nfcTable2 = document.getElementById("nfcTable2");
	var inputs = nfcTable2.getElementsByTagName("input");
	var urlInputs;
	for (var i = 0; i < inputs.length; i++) {

		var iName = inputs[i].name;
		var iVal = inputs[i].value;
		if(inputs[i].getAttribute("type") == 'radio'){
			if (inputs[i].checked){
				url += "&" + iName + "=" + iVal;
			}
		}
		if(inputs[i].getAttribute("type") == 'hidden'){
			url += "&" + iName + "=" + iVal;
		}
		if(inputs[i].getAttribute("type") == 'text'){
			url += "&" + iName + "=" + iVal;
		}
		if(inputs[i].getAttribute("type") == 'checkbox'){
			if (inputs[i].checked){
				url += "&" + iName + "=" + iVal;
			}
		}
	}
	var addUrl = checkWinClose(winClose);
	url += addUrl;
	var milliCache = getCacheBreaker();
	url += '&cachebreaker='+milliCache;
	ajax_loadContent('ibox_content',url ,'<center><div style ="background-color:#C0C0C0; vertical-align:middle; width:755px; height:445px" ><img style="position:relative; top:160px" src=\"/images/netFlowWiz.gif\"></img></div></center>');

}

/******************************************************************

closeBuyNowPopUp() closes all the pbox divs

*******************************************************************/

function closeBuyNowPopUp(){
	delete formObj;
	formObj = null;
	addStartWizInputs('myTask');
	var formObj = new DHTMLSuite.form({formRef:'summaryFormErp', action:'index.cgi?formResponse=YES&netflowSetWiz=netflowSetWizStart', responseEl:'ibox_content', buyNow:'YES', coverDiv:'YES'});

	hideIndicator();
	hideIbox();

	var milliCache = getCacheBreaker();
	var url = 'index.cgi?formResponse=YES&RenderAd=YES';
	url += '&cachebreaker='+milliCache;

	if (document.getElementById('scrutAdSvc2')){
		document.getElementById('scrutAdSvc2').id = 'scrutAdSvc';
		if (document.getElementById('scrutAdSvc')){
			ajax_loadContent('scrutAdSvc',url, '<center><img src=\"/images/smallIndicator.gif\"></img></center>');
		}
	}

	if (document.getElementById('ibox')){
		var iboxNode = document.getElementById('ibox');
		var children = iboxNode.childNodes;
		for (var i = 0; i < children.length; i++) {
			iboxNode.removeChild(children[i]);
		}
		var bod = document.getElementsByTagName("body")[0];
		bod.removeChild(iboxNode);
		window.onscroll = '';
		window.onresize = '';
	}

	manageSelects("inline");
}

/******************************************************************

defaultConf() Opens the old style default add device functionality

*******************************************************************/

function defaultConf(winClose){
	var url = 'index.cgi?formResponse=YES&netflowSetWiz=default';
	var addUrl = checkWinClose(winClose);
	url += addUrl;
	var milliCache = getCacheBreaker();
	url += '&cachebreaker='+milliCache;
	ajax_loadContent('ibox_content',url ,'<center><div style ="background-color:#C0C0C0; vertical-align:middle; width:755px; height:445px" ><img style="position:relative; top:160px" src=\"/images/netFlowWiz.gif\"></img></div></center>');
}

/******************************************************************

saveDefaultConf() gets the inputs from defaulConf and
sends thme to the server via ajax_loadContent()

*******************************************************************/

function saveDefaultConf(buttonIN){

 var checkIP = document.getElementById('0A');
 //savedata(checkIP);
 if (validateIPAddress(checkIP)){
	var url = 'index.cgi?formResponse=YES&netflowSetWiz=default';

	if (buttonIN.name == 'b'){
			var saved = "&" + buttonIN.name + "=" + buttonIN.value;
			url += saved;
	}
	var defaultAddDevice = document.getElementById("defaultAddDevice");
	var inputs = defaultAddDevice.getElementsByTagName("input");
	var urlInputs;
	for (var i = 0; i < inputs.length; i++) {
		var iName = inputs[i].name;
		var iVal = inputs[i].value;
		if(inputs[i].getAttribute("type") == 'radio'){
			if (inputs[i].checked){
				url += "&" + iName + "=" + iVal;
			}
		}
		if(inputs[i].getAttribute("type") == 'hidden'){
			url += "&" + iName + "=" + iVal;
		}
		if(inputs[i].getAttribute("type") == 'text'){
			url += "&" + iName + "=" + iVal;
		}
		if(inputs[i].getAttribute("type") == 'checkbox'){
			if (inputs[i].checked){
				url += "&" + iName + "=" + iVal;
			}
		}

	}

	var selections = defaultAddDevice.getElementsByTagName("select");
	for (var i = 0; i < selections.length; i++) {
				url += "&" + selections[i].name + "=" + selections[i].value;
	}
	var milliCache = getCacheBreaker();
	url += '&cachebreaker='+milliCache;
	ajax_loadContent('ibox_content',url ,'<center><div style ="background-color:#C0C0C0; vertical-align:middle; width:755px; height:445px" ><img style="position:relative; top:160px" src=\"/images/netFlowWiz.gif\"></img></div></center>');
 }
}


/******************************************************************

snmpChange() Re-routes to SNMP Credentials (Manage Credentials)

*******************************************************************/

function snmpChange(snmpOpt){
	var milliCache = getCacheBreaker();
	var url = 'index.cgi?category=Settings&a=SNMP Credentials&noTabs=';
	url += '&cachebreaker='+milliCache;
	if (snmpOpt == "define"){
		window.open(url,'_self');
	}
}

/******************************************************************
for IE 6
manageSelects() hides the select elements
*******************************************************************/

function manageSelects(action){

	var selElements = document.getElementsByTagName("select");
	for (var i = 0; i < selElements.length; i++) {
		selElements[i].style.display = action;
	}

}

/******************************************************************/

function checkWinClose(winClose){

	var addUrl;

	if (winClose == 'YES'){
		addUrl = '&windowClose=YES';
	}
	else {
		addUrl = '&windowClose=NO';
	}
	return addUrl;
}

/******************************************************************/

function stretchIt(){
	document.getElementById('ibox_w').style.height = "100%";
}

/******************************************************************/

function createCred(myIp,returnTo,winClose){
	var url = 'index.cgi?formResponse=YES&netflowSetWiz=createCred&IP=' + myIp + '&returnTo=' + returnTo + '&noTabs=1&noMargins=1';
	var addUrl = checkWinClose(winClose);
	url += addUrl;
	var milliCache = getCacheBreaker();
	url += '&cachebreaker='+milliCache;
	ajax_loadContent('ibox_content',url ,'<center><div style ="background-color:#C0C0C0; vertical-align:middle; width:755px; height:445px" ><img style="position:relative; top:160px" src=\"/images/netFlowWiz.gif\"></img></div></center>');
}

/******************************************************************/

function getValuesAsArray(formRef){
	var retArray = new Object();
	formRef = document.getElementById(formRef);
	var els = formRef.elements;
	for(var no=0;no<els.length;no++){
		if(els[no].disabled)continue;
		var tag = els[no].tagName.toLowerCase();
		switch(tag){
			case "input":
				var type = els[no].type.toLowerCase();
				if(!type)type='text';
				switch(type){
					case "text":
					case "image":
					case "hidden":
					case "password":
						retArray[els[no].name] = els[no].value;
						break;
					case "checkbox":
						var boxes = getFamily(els[no],formRef);
						if(boxes.length>1){
							retArray[els[no].name] = new Array();
							for(var no2=0;no2<boxes.length;no2++){
								if(boxes[no2].checked){
									var index = retArray[els[no].name].length;
									retArray[els[no].name][index] = boxes[no2].value;
								}
							}
						}else{
							if(els[no].checked)retArray[els[no].name] = els[no].value;
						}
						break;
					case "radio":
						if(els[no].checked)retArray[els[no].name] = els[no].value;
						break;

				}
				break;
			case "select":
				var string = '';
				var mult = els[no].getAttribute('multiple');
				if(mult || mult===''){
					retArray[els[no].name] = new Array();
					for(var no2=0;no2<els[no].options.length;no2++){
						var index = retArray[els[no].name].length;
						if(els[no].options[no2].selected)retArray[els[no].name][index] = els[no].options[no2].value;
					}
				}else{
					retArray[els[no].name] = els[no].options[els[no].selectedIndex].value;
				}
				break;
			case "textarea":
				retArray[els[no].name] = els[no].value;
				break;
		}
	}
	return retArray;
}

/******************************************************************/

function isArray(el){
	if(el.constructor.toString().indexOf("Array") != -1)return true;
	return false;
}

/******************************************************************/

/**
 *	Return an array of elements with the same name
 *	@param Object el - Reference to form element
 *	@param Object formRef - Reference to form
 */
function getFamily(el,formRef){
	var els = formRef.elements;
	var retArray = new Array();
	for(var no=0;no<els.length;no++){
		if(els[no].name == el.name)retArray[retArray.length] = els[no];
	}
	return retArray;
}

/******************************************************************/
function createURLFromArray(els){

	var URLString = '';

	for(var prop in els){

		if(isArray(els[prop])){
			for(var no=0;no<els[prop].length;no++){
				var name = prop + '[' + no + ']';

				if(prop.indexOf('[')>=0){ // The name of the form field is already indicating an array
					name = prop.replace('[','[' + no);
				}

				if (els[prop]){
					URLString += "&" + name + "=" + els[prop][no];
				}
			}
		}else{
			if (els[prop]){
				URLString += "&" + prop + "=" + els[prop];
			}
		}
	}

	if (els[prop]){
		URLString += "&" + prop + "=" + els[prop];
	}

	return URLString;

}

/******************************************************************/

function submitNewCred(formRef){

	var URLString = 'index.cgi?formResponse=YES&netflowSetWiz=createCred';

	var els = getValuesAsArray(formRef);

	URLString += createURLFromArray(els);
	var milliCache = getCacheBreaker();
	URLString += '&cachebreaker='+milliCache;

	ajax_loadContent('ibox_content',URLString,'<center><div style ="background-color:#C0C0C0; vertical-align:middle; width:755px; height:445px" ><img style="position:relative; top:160px" src=\"/images/netFlowWiz.gif\"></img></div></center>');

	return false;
}

/******************************************************************/

function deleteCredAjax(formRef){

	var URLString = 'index.cgi?formResponse=YES&netflowSetWiz=createCred&credDelete=1';

	var els = getValuesAsArray(formRef);

	URLString += createURLFromArray(els);

	var milliCache = getCacheBreaker();
	URLString += '&cachebreaker='+milliCache;


	ajax_loadContent('ibox_content',URLString,'<center><div style ="background-color:#C0C0C0; vertical-align:middle; width:755px; height:445px" ><img style="position:relative; top:160px" src=\"/images/netFlowWiz.gif\"></img></div></center>');

	return false;
}

/******************************************************************/

function delete_selected_export(myTask, myName, myDoc, tableID, suppressAlerts, winClose){

	//Pre-process each CHECKBOX
	var anyChecked = 0;
	table = document.getElementById(tableID);
	var delRows = new Array();
	for (var i=1;i<table.rows.length;i++){
		inputs = table.rows[i].getElementsByTagName('input');
		for (ti=0;ti<inputs.length;ti++){
			if (inputs[ti].checked == true){
				anyChecked = 1;
				//table.deleteRow(i);
				delRows.push(i);
				//break;
			}
		}

	}
	// start from back of the array

	if(anyChecked == 0){
		if (! suppressAlerts){
			alert ('Please select a '  + myName + ' to delete');
		}
		return false;
	}

	//if (myDoc == 'NULL'){var myForm = 1;}

	if (myDoc == 'NULL'){
		var myForm = document.forms[0];
	}
	else{
		var myForm = document.getElementById(myDoc);
		//var myForm = myDoc;
	}

	if(confirm('Are you sure you want to delete the selected ' + myName + '?')){
		netflowSetWiz3('delete', winClose);
	}
	else {
		myForm.reset();
	}
}

function getCacheBreaker(){
	var dateObj = new Date();
	var milliCache = dateObj.getTime();
	return milliCache;
}