//	http://www.quirksmode.org/js/introdate.html


//	SPECIAL v6 version with date select reacharound
//		Trigger Scripts

function loadDateDiv(style){

	$("#dateDisplayDiv").html(dateDisplay());	
	//$("#dateDisplayDiv").replaceWith('<div id="dateDisplayDiv">' + dateDisplay() + '</div>');	
	//$("#dateDisplayDiv").replaceWith(dateDisplay());	
	
	
	if(style == 'simple'){
		$("#dateSelectDivHolder").html(dateSelectSimple());
		loadDateDivSimple();
	}else if(style == 'advanced'){
		$("#dateSelectDivHolder").html(dateSelectAdvanced());
		loadDateDivAdvanced()
	}


	$("#calendarStart").livequery(function() { 
	  Calendar.setup(
	    {
	      inputField  : "startDateEpoch",         // ID of the input field
	      ifFormat    : "%s",    			// the date format
	      button      : "calendarStart",       // ID of the button
	      showsTime   : true,
	      timeFormat  : "12",
	      daFormat    : "%A, %B %d, %Y %l:%M %P",
	      onUpdate	  : calendarCheck
	    }
	  );

	});

	$("#calendarEnd").livequery(function() { 
	  Calendar.setup(
	    {
	      inputField  : "endDateEpoch",         // ID of the input field
	      ifFormat    : "%s",    // the date format
	      button      : "calendarEnd",       // ID of the button
	      showsTime   : true,
	      timeFormat  : "12",
	      daFormat    : "%A, %B %d, %Y %l:%M %P",
	      onUpdate	  : calendarCheck
	    }
	  );

	});

	
	setDefaultRange();
	$(".dateMenu li:not('.dateSelectHeader')").livequery('mouseover', function() {
		$(this).css("background-color","#C0D9D9");
	});
	$(".dateMenu li:not('.dateSelectHeader')").livequery('mouseout', function() {
		$(this).css("background-color","#DEDEDE");
	});		
	$("#dateSelectDivHolder").css("display","none");
	
	$(".dateTrigger").livequery('click', function(e) {

		if($("#dateSelectDivHolder").css("display") == 'none'){
			$("body").livequery('click', function() {
				//$("#dateSelectDivHolder").slideUp();
				$("#dateSelectDivHolder").hide();
				$("body").unbind('click');
				var version=parseFloat($.browser.version);
				if(($.browser.msie) && (version<=6)){	
					$("select").show();
				}
			});
		}
		//$("#dateSelectDivHolder").slideDown();
		
		positionSelectDivHolder(e);
		$("#dateSelectDivHolder").show();
		
		var version=parseFloat($.browser.version);
		if(($.browser.msie) && (version<=6)){
			$("select").hide();
		}		
		
		
	});	

	$("#startDateDisplay").livequery('change', function() {
		prettyDateChangeCrunch();
	
	});
	
	$("#endDateDisplay").livequery('change', function() {
		prettyDateChangeCrunch();
	
	});
	

}

function positionSelectDivHolder(e){
	leftVal=e.pageX; 
	topVal=e.pageY; 
	$('#dateSelectDivHolder').css({left:leftVal,top:topVal});
}

function prettyDateChangeCrunch(){
	var startDateIn 	= Date.parse( $("#startDateDisplay").val() );
	
	if(startDateIn == null){
		alert('Invalid Start Date');
		return;
	}
	
	var endDateIn = Date.parse( $("#endDateDisplay").val() );
	if(endDateIn == null){
		alert('Invalid End Date');
		return;
	}
	$("#dateRangeDisplay").html('Custom');
	checkDates(startDateIn,endDateIn);
}

function loadDateDivSimple(){

	
	
	$("#todayStart").livequery('click', function() {
		setRangeToday();
	});
	$("#yesterdayStart").livequery('click', function() {
		setRangeYesterday();

	});	
	$("#last24Start").livequery('click', function() {
		setDefaultRange();

	});
	$("#thisWeekStart").livequery('click', function() {
		setRangeThisWeek();

	});
	$("#lastWeekStart").livequery('click', function() {
		setRangeLastWeek();

	});
	$("#thisMonthStart").livequery('click', function() {
		setRangeThisMonth();

	});
	$("#lastMonthStart").livequery('click', function() {
		setRangeLastMonth();

	});


}

function calendarCheck(calendar){
	$("#dateRangeDisplay").html('Custom');
	var startEpoch	= $('#startDateEpoch').val();
	var endEpoch	= $('#endDateEpoch').val();
	startEpoch *= 1000;
	endEpoch *= 1000;
	
	checkDates(startEpoch,endEpoch);
}


function loadDateDivAdvanced(){



	//	START TRIGGERS
	
	$("#yesterdayStart").livequery('click', function() {
		setStartYesterday();

	});
	$("#mondayStart").livequery('click', function() {
		setStartMonday();

	});
	$("#sundayStart").livequery('click', function() {
		setStartSunday();

	});
	$("#thisMonthStart").livequery('click', function() {
		setStartThisMonth();

	});
	$("#thisYearStart").livequery('click', function() {
		setStartThisYear();

	});


	//	RANGE TRIGGERS
	$("#todayRange").livequery('click', function() {
		setRangeToday();
	});
	$("#yesterdayRange").livequery('click', function() {
		setRangeYesterday();

	});	
	$("#thisWeekRange").livequery('click', function() {
		setRangeThisWeek();

	});
	$("#lastWeekRange").livequery('click', function() {
		setRangeLastWeek();

	});
	$("#thisMonthRange").livequery('click', function() {
		setRangeThisMonth();

	});
	$("#lastMonthRange").livequery('click', function() {
		setRangeLastMonth();

	});

	//	END TRIGGERS
	
	
	//	GLOBAL MENU DISPLAY FUNCTIONS
	$("#closeDateSelect").livequery('click', function() {
		//$("#dateSelectDivHolder").slideUp();
		$("#dateSelectDivHolder").hide();
	});
	
	//	HIGHLIGHT SELECTION STYLING

	$(".dateSelector").livequery('mouseover', function() {
		$(this).css("background-color","");
		$(this).css("font-weight","bold");
		$(this).css("text-indent","6px");
		$(this).css("cursor","pointer");
		

	});
	
	$(".dateSelector").livequery('mouseout', function() {
		$(this).css("background-color","");
		$(this).css("font-weight","");
		$(this).css("text-indent","3px")
		$(this).css("cursor","");
		
	});	
	
}
//	END DATE.HTML

var dateError = '';

//	CONSTANTS
var MINUTE	= 60 * 1000;
var HOUR	= 3600 * 1000;
var DAY		= 86400 * 1000;
var WEEK	= 604800 * 1000;
var DAYS_5	= 432000 * 1000;
var DAYS_30	= 2592000 * 1000;

var weekday 	= new Array("Sunday","Monday","Tuesday","Wednesday","Thursday","Friday","Saturday")
var monthname	= new Array("Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec")
//	COMMON
function checkDates(startEpoch,endEpoch){

	//	ERROR CHECKING
	var now		= new Date();
	var nowEpoch	= now.getTime();

	if(startEpoch > endEpoch){
		alert('START time must be before END time.\nThe default start and end dates will be used.\nTry setting your start date first.');
		dateError = 'Start End Ordering Problem';
		setDefaultRange();
		return 0;
	}else if(startEpoch > nowEpoch){
		alert('A Report can not Start in the future');
		dateError = 'A Report can not Start in the future.\nThe default start and end dates will be used.';
		setDefaultRange();
		return 0;
	}else if(endEpoch > nowEpoch){
		alert('A future end date was selected.\nThe default start and end dates will be used.');
		dateError = 'A Report SHOULD not End in the future';
		var reportPeriod	= endEpoch - startEpoch;
		endEpoch		= nowEpoch;
		startEpoch		= nowEpoch - reportPeriod;
		setDefaultRange();
		return 0;
	}else{
		setDateForm(startEpoch,endEpoch);
		return 1;
	}

}

function setDateForm(startEpoch,endEpoch){
	var startDate 	= new Date(startEpoch);
	var endDate 	= new Date(endEpoch);
	
	var prettyStart		= formatDatePretty(startDate,'us', '0');
	var prettyEnd		= formatDatePretty(endDate,'us', '0');


	$("#startDateDisplay").val(prettyStart);
	$("#endDateDisplay").val(prettyEnd);

	//	Now we format for perl in seconds vs. milliseconds
	startEpoch 	/= 1000;	startEpoch 	= parseInt(startEpoch);
	endEpoch 	/= 1000;	endEpoch 	= parseInt(endEpoch);
	
	//startEpoch -= 40; //subtract 40 seconds so Scrut 7 will shift left 
	
	$("#startDateEpoch").val(startEpoch);
	$("#endDateEpoch").val(endEpoch);

}

function setDateFormStart(startEpoch){
	var startDate 	= new Date(startEpoch);
	var prettyStart		= formatDatePretty(startDate,'us', '0');

	$("#startDateDisplay").html(prettyStart);

	//	Now we format for perl in seconds vs. milliseconds
	startEpoch 	/= 1000;	startEpoch 	= parseInt(startEpoch);
	
	$("#startDateEpoch").val(startEpoch);
	$("#dateRangeDisplay").html('Custom');
}

function setDateFormEnd(endEpoch){
	var endDate 	= new Date(endEpoch);
	
	var prettyEnd		= formatDatePretty(endDate,'us', '0');
	$("#endDateDisplay").html(prettyEnd);

	//	Now we format for perl in seconds vs. milliseconds
	endEpoch 	/= 1000;	endEpoch 	= parseInt(endEpoch);
	
	$("#endDateEpoch").val(endEpoch);
	$("#dateRangeDisplay").html('Custom');
}


function formatDatePretty(dateIn,regional,military){
	var returnah;
	var returnDate;
	var returnTime;
	var minutes	= ((dateIn.getMinutes() < 10) ? "0" : "") + dateIn.getMinutes();
	if(military == 1){
		returnTime	= dateIn.getHour() + ":" + minutes;
	}else{
		var amPm;
		var hour;
		if(dateIn.getHours() == 0){
			hour	= 12;
			amPm 	=  'AM';
		}else if(dateIn.getHours() > 12){
			amPm 	=  'PM';
			hour	= dateIn.getHours()  - 12;
		}else{
			hour	= dateIn.getHours();;
			amPm 	=  'AM';
		}
		returnTime	= hour + ":" + minutes + " " + amPm;
		
	}
	if(regional == 'us'){
		
		returnDate	= monthname[dateIn.getMonth()] + " " + dateIn.getDate() + ", " + takeYear(dateIn) + " " ;		
	}
	
	returnah	= returnDate + returnTime;
	
	return returnah;
}

function newDateToday(leftRightNow){

	var thisDate = new Date();
	if(leftRightNow == 'left'){
		thisDate.setSeconds(0);
		thisDate.setMinutes(0);
		thisDate.setHours(0);
	}else if(leftRightNow == 'right'){
		thisDate.setSeconds(59);
		thisDate.setMinutes(59);
		thisDate.setHours(23);
	}
	
	thisEpoch 	= thisDate.getTime();
	
	return (thisEpoch);
}

function newDateStartOfWeek(){
	var thisDate 	= new Date();
	thisDate.setSeconds(0);
	thisDate.setMinutes(0);
	thisDate.setHours(0);
	thisEpoch 	= thisDate.getTime();
	var thisDow	= thisDate.getDay();
	thisEpoch	= thisEpoch - (thisDow * DAY);
	return (thisEpoch);
}

function newDateStartOfMonth(thisLastNext){
	var thisDate  = new Date();
	var thisMonth = thisDate.getMonth();
	thisDate.setDate(1);
	thisDate.setHours(0);
	thisDate.setSeconds(0);
	thisDate.setMinutes(0);	
	
	if(thisLastNext == "last"){
		var lastMonth	= (thisMonth == 0) ? 11 : (thisMonth - 1);
		thisDate.setMonth(lastMonth);

	}else if(thisLastNext == "next"){
		var nextMonth	= (thisMonth == 11) ? 0 : (thisMonth + 1);
		thisDate.setMonth() += 1;
	}
	
	thisEpoch 	= thisDate.getTime();
	return (thisEpoch);
}

function newDateStartOfYear(){
	var thisDate  = new Date();
	var thisMonth = thisDate.getMonth();
	alert(thisDate);
	thisDate.setDate(1);
	thisDate.setHours(0);
	thisDate.setSeconds(0);
	thisDate.setMinutes(0);
	thisDate.setMonth(0)	
	
	thisEpoch 	= thisDate.getTime();
	return (thisEpoch);
}

function takeYear(theDate) {
	x = theDate.getYear();
	var y = x % 100;
	y += (y < 38) ? 2000 : 1900;
	return y;
}

//	RANGES

function setDefaultRange(){

	//alert('Last 24 Hours');(
	$("#dateRangeDisplay").html('Last 24 Hrs');
	var startEpoch	= newDateToday('now') - DAY;
	var endEpoch	= newDateToday('now');
	checkDates(startEpoch,endEpoch);
}

function setRangeToday(){
	//alert('today');(
	$("#dateRangeDisplay").html('Today');
	var startEpoch	= newDateToday('left');
	var endEpoch	= newDateToday('now');
	checkDates(startEpoch,endEpoch);

	
}
function setRangeYesterday(){
	//alert('yesterday');
	$("#dateRangeDisplay").html('Yesterday');
	var startEpoch	= newDateToday('left') - DAY;
	var endEpoch	= newDateToday('right') - DAY;
	checkDates(startEpoch,endEpoch);
}
function setRangeThisWeek(){
	//alert('This Week');
	$("#dateRangeDisplay").html('This Week');
	var startEpoch	= newDateStartOfWeek() ;
	var endEpoch	= newDateToday('now');
	checkDates(startEpoch,endEpoch);
}
function setRangeLastWeek(){
	//alert('Last Week');
	$("#dateRangeDisplay").html('Last Week');
	var startEpoch	= newDateStartOfWeek();
	startEpoch	-= WEEK;
	var endEpoch	= startEpoch + WEEK - 1000;
	checkDates(startEpoch,endEpoch);
}
function setRangeThisMonth(){
	//alert('This Month'); 
	$("#dateRangeDisplay").html('This Month');
	var startEpoch	= newDateStartOfMonth('this');
	var endEpoch	= newDateToday('now');
	checkDates(startEpoch,endEpoch);

}
function setRangeLastMonth(){
	//alert('Last Month');
	$("#dateRangeDisplay").html('Last Month');
	var startEpoch	= newDateStartOfMonth('last');
	var endEpoch	= newDateStartOfMonth('this') - 1000;
	checkDates(startEpoch,endEpoch);

}
function setRangeThisYear(){
	//alert('This Year');
	$("#dateRangeDisplay").html('(This Year - WIP)');
	var startEpoch	= newDateStartOfMonth('last');
	var endEpoch	= newDateStartOfMonth('this') - 1000;
	checkDates(startEpoch,endEpoch);
}
function setRangeLastYear(){
	//alert('Last Year');
	$("#dateRangeDisplay").html('(Last Year - WIP)');
	var startEpoch	= newDateStartOfMonth('last');
	var endEpoch	= newDateStartOfMonth('this') - 1000;
	checkDates(startEpoch,endEpoch);

}
function setRangeLastXDays(days){
	//alert('Last X Days');(
	$("#dateRangeDisplay").html('(Last ' + days + ' Days)');
	var startEpoch	= newDateToday('left') - (days * DAY);
	var endEpoch	= newDateToday('now');
	checkDates(startEpoch,endEpoch);
}
function setRangeLastXWeeks(weeks){
	//alert('Last X Weeks');(
	$("#dateRangeDisplay").html('(Last ' + weeks + ' Weeks)');
	var startEpoch	= newDateToday('left') - (weeks * WEEK);
	var endEpoch	= newDateToday('now');
	checkDates(startEpoch,endEpoch);
}
function setRangeLastXMonths(months){
	//alert('Last X Months');(
	$("#dateRangeDisplay").html('(Last ' + months + ' Months)');
	var startEpoch	= newDateToday('left') - (months * MONTH);
	var endEpoch	= newDateToday('now');
	checkDates(startEpoch,endEpoch);

}


//	START OPTIONS

function setStartYesterday(){
	var startEpoch	= newDateToday('left') - DAY;
	setDateFormStart(startEpoch);
}
function setStartMonday(){
	var startEpoch = newDateStartOfWeek() + DAY;
	setDateFormStart(startEpoch);
}
function setStartSunday(){
	var startEpoch = newDateStartOfWeek();
	setDateFormStart(startEpoch);

}
function setStartThisMonth(){
	var startEpoch	= newDateStartOfMonth('this');
	setDateFormStart(startEpoch);
}
function setStartLastMonth(){
	var startEpoch	= newDateStartOfMonth('last');
	setDateFormStart(startEpoch);
}

function setStartThisYear(){
	var startEpoch	= newDateStartOfYear();
	setDateFormStart(startEpoch);
}




//	END OPTIONS

function setEndToday(){
	var endEpoch	= newDateToday('right');
	setDateFormEnd(endEpoch);
}
function setEndYesterday(){
	var endEpoch	= newDateToday('right') - DAY;
	setDateFormEnd(endEpoch);

}
function setEndThisMonth(){
	var endEpoch	= newDateStartOfMonth('next') - 1000;
	setDateFormEnd(endEpoch);

}
function setEndLastMonth(){

}
function setEndThisYear(){

}
function setEndLastYear(){

}
 
//	DISPLAY FUNCTIONS
function dateDisplay(){
	var menu = '\
		<div id="dateRangeDisplayHolder">\
			<div  id="dateRangeDisplay" class="dateTrigger">\
					(Custom)\
			</div>\
		</div>\
		<form id="statusDateForm">\
		<img src="/icons/calendar.jpg" class="inlineImage" id="calendarStart">\
		<input type=textbox  id="startDateDisplay" class="defaultText"> to <input type=textbox id="endDateDisplay" class="defaultText">\
		<img src="/icons/calendar.jpg" class="inlineImage" id="calendarEnd">\
		<div class="hidden">\
			<input name="startDateEpoch" id="startDateEpoch">\
			<input name="endDateEpoch" id="endDateEpoch">\
		</div>\
		<div id="dateSelectDivHolder" title="Click here to change date range">\
		</div>\
		</form>';
	return menu;
	
}

function dateSelectSimple(){
	var dateSelector = '<div id="dateSelectDiv" class=dateMenu>\
		<ul class=dateMenu>\
		<li id="" class="dateSelectHeader">Select Time Frame  </li>\
		<li id="todayStart">Today  </li>\
		<li id="yesterdayStart">Yesterday  </li>\
		<li id="last24Start">Last 24 Hrs  </li>\
		<li id="thisWeekStart">This Week  </li>\
		<li id="lastWeekStart">Last Week </li>\
		<li id="thisMonthStart">This Month  </li>\
		<li id="lastMonthStart">Last Month  </li>\
		<li id="closedateSelectDivHolder">Close Menu </li>\
		</ul>\
	</div>';
	
	return dateSelector;
}

function dateSelectAdvanced(){
	var dateSelector = '<div id="dateSelectDiv">\
		<div id="dateStartSelect" class="dateMenu dateMenuFloater">\
			<ul class="dateMenu">\
			<li id="calendarStart" class="dateHeader dateSelector">SET START <img src="/images/common/calendar.jpg" class="inlineImage">  </li>\
			<li id="yesterdayStart" class="dateSelector">Yesterday  </li>\
			<li id="mondayStart" class="dateSelector">Monday  </li>\
			<li id="sundayStart" class="dateSelector">Sunday </li>\
			<li id="thisMonthStart" class="dateSelector">First of Month  </li>\
			<li id="lastYearStart" class="dateSelector">First of Year  </li>\
			</ul>\
		</div>\
		<div id="dateRangeSelectDiv" class="dateMenu dateMenuFloater">\
			<ul class="dateMenu">\
			<li id="" class="dateHeader">SET RANGE </li>\
			<li id="todayRange" class="dateSelector">Today  </li>\
			<li id="yesterdayRange" class="dateSelector">Yesterday  </li>\
			<li id="thisWeekRange" class="dateSelector">This Week  </li>\
			<li id="lastWeekRange" class="dateSelector">Last Week </li>\
			<li id="thisMonthRange" class="dateSelector">This Month  </li>\
			<li id="lastMonthRange" class="dateSelector">Last Month  </li>\
			<li id="closeDateSelect" class="dateSelector">Close Menu </li>\
			</ul>\
		</div>\
		<div id="dateEndSelect" class="dateMenu dateMenuFloater">\
			<ul class="dateMenu">\
			<li id="calendarEnd" class="dateHeader dateSelector">SET END <img src="/images/common/calendar.jpg" class="inlineImage">  </li>\
			<li id="todayEnd" class="dateSelector">Today </li>\
			<li id="yesterdayEnd" class="dateSelector">Yesterday  </li>\
			<li id="fridayEnd" class="dateSelector">Friday  </li>\
			<li id="saturdayEnd" class="dateSelector">Saturday </li>\
			<li id="thisMonthEnd" class="dateSelector">This Month  </li>\
			<li id="lastMonthEnd" class="dateSelector">Last Month  </li>\
			</ul>\
		</div>\
	</div>';
	return dateSelector;
}
